﻿Imports System.Net.NetworkInformation

Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub ParallelPing(sender As Object, e As EventArgs)
        Dim sites As New List(Of String)
        sites.Add("www.yahoo.com")
        sites.Add("www.google.com")
        sites.Add("www.aspsnippets.com")

     Dim pingReplies As List(Of PingReply) = TryCast((
                     From site In sites.AsParallel().WithDegreeOfParallelism(sites.Count) _
                     Select DoPing(site)).ToList(), List(Of PingReply))

        For Each s In pingReplies.ToList()
            Response.Write(Convert.ToString(s.Address) & ": " & Convert.ToString(s.RoundtripTime) & ": " & Convert.ToString(s.Status) & "<br />")
        Next

    End Sub


    Private Function DoPing(ByVal site As String) As PingReply
        Dim p As New Ping()
        Return p.Send(site)
    End Function

End Class
